<?php
/**
* @version   $Id: gspeech.php 22 2012-03-25 15:42:53Z info@creative-solutions.net $
* @package   GSpeech
* @copyright Copyright (C) 2012 - 2023 creative-solutions.net. All rights reserved.
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
jimport('joomla.html.parameter');

/**
 * GSpeech plugin
 */
class  plgSystemGspeech extends JPlugin {

    // 3.1.0 update
    private $_plugin;
    private $_params;
    private $conf;

    function __construct(&$subject,$config) {
        parent::__construct($subject,$config);

        // load plugin parameters and language file
        $this->_plugin = JPluginHelper::getPlugin('system','gspeech');
        $this->_params = json_decode($this->_plugin->params);
        $this->conf = $config;
        JPlugin::loadLanguage('plg_system_gspeech', JPATH_ADMINISTRATOR);
    }
    
    function onAfterRender() {
       $mainframe = JFactory::getApplication();

        if($mainframe->isClient('administrator'))
            return;

        $pluginParams = new JRegistry($this->conf['params']);
        $widget_id = $pluginParams->get('widget_id');
        $widget_code = '<script async src="https://gspeech.io/widget/'.$widget_id.'"></script>' . "\n";
        
        $content = $mainframe->getBody();

        // 3.2.0 shortcodes
        $content = preg_replace('/\[gspeech\]/si', '<!-- START gspeech.io --><div class="gsp_full_player"></div><!-- END gspeech -->', $content);
        $content = preg_replace('/\[gspeech type=full\]/si', '<!-- START gspeech.io --><div class="gsp_full_player"></div><!-- END gspeech -->', $content);
        $content = preg_replace('/\[gspeech type=button\]/si', '<!-- START gspeech.io --><div class="gsp_button_player"></div><!-- END gspeech -->', $content);
        $content = preg_replace('/\[gspeech type=circle\]/si', '<!-- START gspeech.io --><div class="gsp_circle_player"></div><!-- END gspeech -->', $content);

        // custom id
        $content = preg_replace('/\[gspeech id=(\d+)\]/si', '<!-- START gspeech.io --><div class="gsp_shortcode_$1"></div><!-- END gspeech -->', $content);

        // shortcode inner text structrue
        $content = preg_replace('/\{gspeech id=(\d+)\}(.*?)\{\/gspeech\}/si', '<div class="gsp_inline_shortcode"><div class="gsp_inline_shortcode_player_wrp"><div class="gsp_shortcode_$1"></div></div><div class="gsp_inline_shortcode_txt_wrp"><div class="gsp_shortcode_txt_element gsp_shortcode_wrp_$1">$2</div></div></div>', $content);

        // shortcode inner text with class structrue
        $content = preg_replace('/\{gspeech id=(\d+) class=([a-zA-Z0-9-_ ]+)\}(.*?)\{\/gspeech\}/si', '<div class="gsp_inline_shortcode $2"><div class="gsp_inline_shortcode_player_wrp"><div class="gsp_shortcode_$1"></div></div><div class="gsp_inline_shortcode_txt_wrp"><div class="gsp_shortcode_txt_element gsp_shortcode_wrp_$1">$3</div></div></div>', $content);

        $content = str_replace('</body>', $widget_code . '</body>', $content);

        $mainframe->setBody($content);
    }
}